diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-content/themes/twentyten/loop-attachment.php ./wordpress-3.3/wp-content/themes/twentyten/loop-attachment.php
*** ./wordpress-3.2.1/wp-content/themes/twentyten/loop-attachment.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-content/themes/twentyten/loop-attachment.php	2011-12-10 13:18:51.000000000 -0600
***************
*** 18,24 ****
  <?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
  
  				<?php if ( ! empty( $post->post_parent ) ) : ?>
! 					<p class="page-title"><a href="<?php echo get_permalink( $post->post_parent ); ?>" title="<?php esc_attr( printf( __( 'Return to %s', 'twentyten' ), get_the_title( $post->post_parent ) ) ); ?>" rel="gallery"><?php
  						/* translators: %s - title of parent post */
  						printf( __( '<span class="meta-nav">&larr;</span> %s', 'twentyten' ), get_the_title( $post->post_parent ) );
  					?></a></p>
--- 18,24 ----
  <?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
  
  				<?php if ( ! empty( $post->post_parent ) ) : ?>
! 					<p class="page-title"><a href="<?php echo get_permalink( $post->post_parent ); ?>" title="<?php echo esc_attr( sprintf( __( 'Return to %s', 'twentyten' ), strip_tags( get_the_title( $post->post_parent ) ) ) ); ?>" rel="gallery"><?php
  						/* translators: %s - title of parent post */
  						printf( __( '<span class="meta-nav">&larr;</span> %s', 'twentyten' ), get_the_title( $post->post_parent ) );
  					?></a></p>
***************
*** 33,39 ****
  								'meta-prep meta-prep-author',
  								sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s" rel="author">%3$s</a></span>',
  									get_author_posts_url( get_the_author_meta( 'ID' ) ),
! 									sprintf( esc_attr__( 'View all posts by %s', 'twentyten' ), get_the_author() ),
  									get_the_author()
  								)
  							);
--- 33,39 ----
  								'meta-prep meta-prep-author',
  								sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s" rel="author">%3$s</a></span>',
  									get_author_posts_url( get_the_author_meta( 'ID' ) ),
! 									esc_attr( sprintf( __( 'View all posts by %s', 'twentyten' ), get_the_author() ) ),
  									get_the_author()
  								)
  							);
***************
*** 85,91 ****
  		$next_attachment_url = wp_get_attachment_url();
  	}
  ?>
! 						<p class="attachment"><a href="<?php echo $next_attachment_url; ?>" title="<?php echo esc_attr( get_the_title() ); ?>" rel="attachment"><?php
  							$attachment_width  = apply_filters( 'twentyten_attachment_size', 900 );
  							$attachment_height = apply_filters( 'twentyten_attachment_height', 900 );
  							echo wp_get_attachment_image( $post->ID, array( $attachment_width, $attachment_height ) ); // filterable image width with, essentially, no limit for image height.
--- 85,91 ----
  		$next_attachment_url = wp_get_attachment_url();
  	}
  ?>
! 						<p class="attachment"><a href="<?php echo $next_attachment_url; ?>" title="<?php the_title_attribute(); ?>" rel="attachment"><?php
  							$attachment_width  = apply_filters( 'twentyten_attachment_size', 900 );
  							$attachment_height = apply_filters( 'twentyten_attachment_height', 900 );
  							echo wp_get_attachment_image( $post->ID, array( $attachment_width, $attachment_height ) ); // filterable image width with, essentially, no limit for image height.
***************
*** 96,102 ****
  							<div class="nav-next"><?php next_image_link( false ); ?></div>
  						</div><!-- #nav-below -->
  <?php else : ?>
! 						<a href="<?php echo wp_get_attachment_url(); ?>" title="<?php echo esc_attr( get_the_title() ); ?>" rel="attachment"><?php echo basename( get_permalink() ); ?></a>
  <?php endif; ?>
  						</div><!-- .entry-attachment -->
  						<div class="entry-caption"><?php if ( !empty( $post->post_excerpt ) ) the_excerpt(); ?></div>
--- 96,102 ----
  							<div class="nav-next"><?php next_image_link( false ); ?></div>
  						</div><!-- #nav-below -->
  <?php else : ?>
! 						<a href="<?php echo wp_get_attachment_url(); ?>" title="<?php the_title_attribute(); ?>" rel="attachment"><?php echo basename( get_permalink() ); ?></a>
  <?php endif; ?>
  						</div><!-- .entry-attachment -->
  						<div class="entry-caption"><?php if ( !empty( $post->post_excerpt ) ) the_excerpt(); ?></div>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-content/themes/twentyten/loop-single.php ./wordpress-3.3/wp-content/themes/twentyten/loop-single.php
*** ./wordpress-3.2.1/wp-content/themes/twentyten/loop-single.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-content/themes/twentyten/loop-single.php	2011-12-10 13:18:51.000000000 -0600
***************
*** 40,46 ****
  							<?php echo get_avatar( get_the_author_meta( 'user_email' ), apply_filters( 'twentyten_author_bio_avatar_size', 60 ) ); ?>
  						</div><!-- #author-avatar -->
  						<div id="author-description">
! 							<h2><?php printf( esc_attr__( 'About %s', 'twentyten' ), get_the_author() ); ?></h2>
  							<?php the_author_meta( 'description' ); ?>
  							<div id="author-link">
  								<a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ) ); ?>" rel="author">
--- 40,46 ----
  							<?php echo get_avatar( get_the_author_meta( 'user_email' ), apply_filters( 'twentyten_author_bio_avatar_size', 60 ) ); ?>
  						</div><!-- #author-avatar -->
  						<div id="author-description">
! 							<h2><?php printf( __( 'About %s', 'twentyten' ), get_the_author() ); ?></h2>
  							<?php the_author_meta( 'description' ); ?>
  							<div id="author-link">
  								<a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ) ); ?>" rel="author">
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-cron.php ./wordpress-3.3/wp-cron.php
*** ./wordpress-3.2.1/wp-cron.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-cron.php	2011-09-09 14:59:44.000000000 -0500
***************
*** 26,31 ****
--- 26,49 ----
  	require_once('./wp-load.php');
  }
  
+ // Uncached doing_cron transient fetch
+ function _get_cron_lock() {
+ 	global $_wp_using_ext_object_cache, $wpdb;
+ 
+ 	$value = 0;
+ 	if ( $_wp_using_ext_object_cache ) {
+ 		// Skip local cache and force refetch of doing_cron transient in case
+ 		// another processs updated the cache
+ 		$value = wp_cache_get( 'doing_cron', 'transient', true );
+ 	} else {
+ 		$row = $wpdb->get_row( $wpdb->prepare( "SELECT option_value FROM $wpdb->options WHERE option_name = %s LIMIT 1", '_transient_doing_cron' ) );
+ 		if ( is_object( $row ) )
+ 			$value = $row->option_value;
+ 	}
+ 
+ 	return $value;
+ }
+ 
  if ( false === $crons = _get_cron_array() )
  	die();
  
***************
*** 35,60 ****
  if ( isset($keys[0]) && $keys[0] > $local_time )
  	die();
  
! foreach ($crons as $timestamp => $cronhooks) {
  	if ( $timestamp > $local_time )
  		break;
  
! 	foreach ($cronhooks as $hook => $keys) {
  
! 		foreach ($keys as $k => $v) {
  
  			$schedule = $v['schedule'];
  
! 			if ($schedule != false) {
  				$new_args = array($timestamp, $schedule, $hook, $v['args']);
  				call_user_func_array('wp_reschedule_event', $new_args);
  			}
  
! 			wp_unschedule_event($timestamp, $hook, $v['args']);
  
!  			do_action_ref_array($hook, $v['args']);
  		}
  	}
  }
  
  die();
--- 53,104 ----
  if ( isset($keys[0]) && $keys[0] > $local_time )
  	die();
  
! $doing_cron_transient = get_transient( 'doing_cron');
! 
! // Use global $doing_wp_cron lock otherwise use the GET lock. If no lock, trying grabbing a new lock.
! if ( empty( $doing_wp_cron ) ) {
! 	if ( empty( $_GET[ 'doing_wp_cron' ] ) ) {
! 		// Called from external script/job. Try setting a lock.
! 		if ( $doing_cron_transient && ( $doing_cron_transient + WP_CRON_LOCK_TIMEOUT > $local_time ) )
! 			return;
! 		$doing_cron_transient = $doing_wp_cron = time();
! 		set_transient( 'doing_cron', $doing_wp_cron );
! 	} else {
! 		$doing_wp_cron = $_GET[ 'doing_wp_cron' ];
! 	}
! }
! 
! // Check lock
! if ( $doing_cron_transient != $doing_wp_cron )
! 	return;
! 
! foreach ( $crons as $timestamp => $cronhooks ) {
  	if ( $timestamp > $local_time )
  		break;
  
! 	foreach ( $cronhooks as $hook => $keys ) {
  
! 		foreach ( $keys as $k => $v ) {
  
  			$schedule = $v['schedule'];
  
! 			if ( $schedule != false ) {
  				$new_args = array($timestamp, $schedule, $hook, $v['args']);
  				call_user_func_array('wp_reschedule_event', $new_args);
  			}
  
! 			wp_unschedule_event( $timestamp, $hook, $v['args'] );
  
!  			do_action_ref_array( $hook, $v['args'] );
! 
! 			// If the hook ran too long and another cron process stole the lock, quit.
! 			if ( _get_cron_lock() != $doing_wp_cron )
! 				return;
  		}
  	}
  }
  
+ if ( _get_cron_lock() == $doing_wp_cron )
+ 	delete_transient( 'doing_cron' );
+ 
  die();
